#ifndef __PROCMIME_H__
#define __PROCMIME_H__

#include <glib.h>

typedef struct _MimeInfo	MimeInfo;

typedef enum
{
	ENC_7BIT,
	ENC_QUOTED_PRINTABLE,
	ENC_BASE64,
	ENC_UNKNOWN
} EncodingType;

typedef enum
{
	MIME_TEXT,
	MIME_APPLICATION,
	MIME_MULTIPART,
	MIME_UNKNOWN
} MimeType;

struct _MimeInfo
{
	gchar *encoding;

	EncodingType encoding_type;

	gchar *content_type;
	gchar *charset;
	gchar *name;
	gchar *boundary;

	MimeType mime_type;

	gchar *content_disposition;

	glong fpos;
};

MimeInfo *procmime_mimeinfo_new		(void);
void procmime_mimeinfo_free		(MimeInfo	*mimeinfo);
void procmime_scan_encoding		(MimeInfo	*mimeinfo,
					 const gchar	*encoding);
void procmime_scan_content_type		(MimeInfo	*mimeinfo,
					 const gchar	*content_type);
MimeInfo *procmime_scan_mime_header	(FILE		*fp);

#endif /* __PROCMIME_H__ */
